package name.nathanmcrae;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.dataformat.xml.XmlMapper;
import java.io.File;
import java.io.IOException;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.event.Event;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.scene.Node;
import javafx.stage.Stage;

public class NumbersStationSettingsController {
    private StationSettings settings;
    private StringProperty stationAddress = new SimpleStringProperty();
    private StringProperty stationName = new SimpleStringProperty();

    @FXML
    private TextField stationNameField;

    @FXML
    private TextField stationAddressField;

    public NumbersStationSettingsController() throws IOException {
        // System.out.println("Created settings controller");
        // File file = new File("setting-test.xml");
        // XmlMapper xmlMapper = new XmlMapper();
        // settings = xmlMapper.readValue(file, NumbersStationSettings.class);
        // settings.setRefreshInterval(settings.getRefreshInterval() + 40);
        // settings.getStations().add(new StationSettings());
    }

    @FXML
    private void initialize() {
        stationNameField.textProperty().bindBidirectional(stationName);
        stationAddressField.textProperty().bindBidirectional(stationAddress);
    }

    @FXML
    private void handleSaveButtonPress(Event e) {
        settings.setAddress(stationAddress.get());

        Node node = (Node) e.getSource();
        Stage stage = (Stage) node.getScene().getWindow();
        stage.setUserData(true);
        stage.close();
    }

    @FXML
    private void handleCancelButtonPress(Event e) {
        Node node = (Node) e.getSource();
        Stage stage = (Stage) node.getScene().getWindow();
        stage.setUserData(false);
        stage.close();
    }

    public StringProperty stationAddressProperty() {
        return stationAddress;
    }

    public void setStationSettings(StationSettings newSettings) {
        settings = newSettings;
        stationName.set(settings.getName());
    }
}
